// OutputStream.cpp : Implementation of COutputStream
#include "stdafx.h"
#include "SimpleConnector.h"
#include "OutputStream.h"
#include "Connector.h"
/////////////////////////////////////////////////////////////////////////////
// COutputStream
void COutputStream::init(CConnector* pConn)
{
    m_pConn = pConn;
}

// IStream
STDMETHODIMP COutputStream::Seek(_LARGE_INTEGER /*dlibMove*/, ULONG /*dwOrigin*/, _ULARGE_INTEGER * /*plibNewPosition*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP COutputStream::SetSize(_ULARGE_INTEGER /*libNewSize*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP COutputStream::CopyTo(IStream * /*pstm*/, _ULARGE_INTEGER /*cb*/, _ULARGE_INTEGER * /*pcbRead*/, _ULARGE_INTEGER * /*pcbWritten*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP COutputStream::Commit(ULONG /*grfCommitFlags*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP COutputStream::Revert()
{
    return E_NOTIMPL;
}
STDMETHODIMP COutputStream::LockRegion(_ULARGE_INTEGER /*libOffset*/, _ULARGE_INTEGER /*cb*/, ULONG /*dwLockType*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP COutputStream::UnlockRegion(_ULARGE_INTEGER /*libOffset*/, _ULARGE_INTEGER /*cb*/, ULONG /*dwLockType*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP COutputStream::Stat(tagSTATSTG * /*pstatstg*/, ULONG /*grfStatFlag*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP COutputStream::Clone(IStream * * /*ppstm*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP COutputStream::Read(void * pv, ULONG cb, ULONG * pcbRead)
{
    return m_pConn->receive(pv, cb, pcbRead);
}

STDMETHODIMP COutputStream::Write(const void * /*pv*/, ULONG /*cb*/, ULONG * /*pcbWritten*/)
{
    return E_NOTIMPL;
}

// IGetParserSource
STDMETHODIMP COutputStream::get_ParserSource(IParserSource * * par_value)
{
    *par_value = IParserSourcePtr(GetUnknown()).Detach();
    return S_OK;
}
// IParserSource
STDMETHODIMP COutputStream::get_Property(BSTR par_name, VARIANT * par_value)
{
    _bstr_t val;
    
    HRESULT hr = m_pConn->get_property(par_name, val);
    if(SUCCEEDED(hr))
        *par_value = _variant_t(val).Detach();
    return hr;
}
STDMETHODIMP COutputStream::put_Property(BSTR /*par_name*/, VARIANT /*par_value*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP COutputStream::BeginReceiving(ISequentialStream * * par_stream)
{
    *par_stream = IStreamPtr(GetUnknown()).Detach();
    return S_OK;
}
STDMETHODIMP COutputStream::EndReceiving()
{
    return S_OK;
}
