// DataObject.h : Declaration of the CDataObject

#ifndef __DATAOBJECT_H_
#define __DATAOBJECT_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CDataObject
class ATL_NO_VTABLE CDataObject : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDataObject, &CLSID_DataObject>,
	public IDispatchImpl<IGCTMDataObject, &IID_IGCTMDataObject, &LIBID_MAPPERSAMPLESRVLib>
{
public:
	CDataObject()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_DATAOBJECT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CDataObject)
	COM_INTERFACE_ENTRY(IGCTMDataObject)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IDataObject
public:
	STDMETHOD(get_Data)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Data)(/*[in]*/ BSTR newVal);

    
    CComBSTR m_bstr;    
};

#endif //__DATAOBJECT_H_
