// PersistObj.cpp : Implementation of CPersistObj
#include "stdafx.h"
#include "MapperSampleSrv.h"
#include "PersistObj.h"

/////////////////////////////////////////////////////////////////////////////
// CPersistObj


STDMETHODIMP CPersistObj::Get(_Recordset **pData)
{
	// TODO: Add your implementation code here
    _RecordsetPtr pRecordset(__uuidof(Recordset));
    pRecordset->CursorLocation = adUseClient;
    FieldsPtr pFields = pRecordset->Fields;
    pFields->Append(L"id", adInteger, 0, adFldUnspecified);
    pFields->Append(L"name", adBSTR, 0, adFldUnspecified);
    pRecordset->Open(vtMissing, vtMissing, adOpenStatic,
        adLockBatchOptimistic, adOptionUnspecified);
    pRecordset->AddNew();
    pFields->Item[L"id"]->Value = (long) 1;
    pFields->Item[L"name"]->Value = L"123";

    *pData = pRecordset.Detach();
	return S_OK;
}
