// PersistObj.h : Declaration of the CPersistObj

#ifndef __PERSISTOBJ_H_
#define __PERSISTOBJ_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CPersistObj
class ATL_NO_VTABLE CPersistObj : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CPersistObj, &CLSID_PersistObj>,
	public IDispatchImpl<IPersistObj, &IID_IPersistObj, &LIBID_MAPPERSAMPLESRVLib>
    
{
public:
	CPersistObj()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_PERSISTOBJ)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CPersistObj)
	COM_INTERFACE_ENTRY(IPersistObj)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IPersistObj
public:
	STDMETHOD(Get)(/*[out]*/_Recordset** pData);
};

#endif //__PERSISTOBJ_H_
